/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Insercoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */
public class Insercao_ILS extends Insercoes{

    @Override
    public Solucao execute(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand) {
 
        //Embaralhando conjQ
        Collections.shuffle(conjQ);
        
        //
        Solucao solPert = new Solucao(instancia); //Solução Pertubada
        solPert.clonarSolucoes(sol);
        
        while(conjQ.size() > 0){
        
            //M1
            int randMaquina1 = rand.nextInt(instancia.getNumMaqs());
            //while(sol.getSol().get(randMaquina1).size() <= 1){
            while(sol.getSol().get(randMaquina1).size() < 1){
                randMaquina1 = rand.nextInt(instancia.getNumMaqs());
                //System.out.println("Preso1 => inserção ILS");
                //sol.imprimirSolucao();
            }
            
            //M2
            int randMaquina2 = rand.nextInt(instancia.getNumMaqs());
            //while(sol.getSol().get(randMaquina2).size() <= 1){
            while(sol.getSol().get(randMaquina2).size() < 1){
                randMaquina2 = rand.nextInt(instancia.getNumMaqs());
                //System.out.println("Preso2 => inserção ILS");
            }    

            //System.out.println("Passei");
            
            //
            int tarefaRetirada1 = conjQ.get(0);
            conjQ.remove(0);
            //System.out.println(tarefaRetirada1);
            
            //Armazerá as posições
            int posicaoEscolhida;
            boolean ultimaPosicao = false;

            //Inserindo a Tarefa na Máquina 2
            double auxCusto = Double.MAX_VALUE;
            for(int i=0; i < sol.getSol().get(randMaquina2).size()+1; i++){

                Solucao sol2 = new Solucao(instancia);
                sol2.clonarSolucoes(sol);

                //Última Posição
                if(i == (sol2.getSol().get(randMaquina2).size()) ){ //Último item
                    sol2.getSol().get(randMaquina2).add(tarefaRetirada1);
                    ultimaPosicao = true;
                }
                //Posição Intermediária
                else {
                    ultimaPosicao = false;
                    sol2.getSol().get(randMaquina2).add(i, tarefaRetirada1);
                }

                //Atualizando a Posição Escolhida
                if(!ultimaPosicao)
                   posicaoEscolhida = i;
                else
                   posicaoEscolhida = sol2.getSol().get(randMaquina2).size()-1;

                //Custo - Inserindo a Tarefa
                double custoInserir = sol2.regraDelta_Inserir2(instancia, randMaquina2, tarefaRetirada1, posicaoEscolhida);
                sol2.getCustoMaq().set(randMaquina2, (sol2.getCustoMaq().get(randMaquina2) + custoInserir));

                if(custoInserir < auxCusto){
                    auxCusto = custoInserir;
                    solPert.clonarSolucoes(sol2);
                }
            }
            
            sol.clonarSolucoes(solPert);
        
        }
        
        return sol;
    
    }

    @Override
    public int getIndice() {
        return 6;
    }
    
}
