/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Remocoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Remove as q tarefas maiores (tempoPrep + tempoProc)
public class RemocaoMaiorCusto_Gulosa extends Remocoes{
    
    public ArrayList<Integer> execute(Solucao sol, Instancia instancia, int tamQ, Random rand){
    
        ArrayList<Integer> conjQ = new ArrayList<Integer>();

        //Declarando Listas
        ArrayList<Integer> conjMaquinas = new ArrayList<Integer>(); //Máquina que a tarefa está alocada
        ArrayList<Integer> conjCusto = new ArrayList<Integer>(); //Custo da tarefa
        ArrayList<Integer> conjJobs = new ArrayList<Integer>(); //Conjunto de tarefas
                
        // Pegando o custo de cada tarefa
        for(int k=0; k < instancia.getNumMaqs(); k++){
            for(int auxJ=0; auxJ < sol.getSol().get(k).size(); auxJ++){
        
                int tarefaAnt = 0;
                if(auxJ > 0)
                    tarefaAnt = sol.getSol().get(k).get(auxJ-1);
          
                int tarefa = sol.getSol().get(k).get(auxJ);
                int tempoProc = instancia.getProc()[k][tarefa];
                int tempoPrep = instancia.getPrep()[k][tarefaAnt][tarefa];
                
                //Armazenando os custos
                conjCusto.add(tempoPrep + tempoProc);
                conjJobs.add(tarefa);
                conjMaquinas.add(k);
                        
            }
        }    
        
        //System.out.println(conjCusto);
        //System.out.println(conjJobs);
        //System.out.println(conjMaquinas);
        
        //Removendo as q maiores tarefas
        while(tamQ > conjQ.size()){
        
            //Pegando o maior custo
            int posicao = conjCusto.indexOf(Collections.max(conjCusto)); //Pega a posicao de custo maior
            int tarefa = conjJobs.get(posicao); //Pega a tarefa correspondente ao custo anterior
            int maquina = conjMaquinas.get(posicao); //Pega a máquina correspondente
                        
            //Remove o maior custo
            conjCusto.remove(posicao); //Remove o custo
            conjJobs.remove(posicao); //Remove a tarefa
            conjMaquinas.remove(posicao); //Remove a máquina
            
            //Atualiza o custo da máquina
            double novoCusto = sol.regraDelta_Retirar2(instancia, maquina, tarefa, sol.getSol().get(maquina).indexOf(tarefa));
            sol.getCustoMaq().set(maquina, (sol.getCustoMaq().get(maquina) + novoCusto));
          
            //Remove a  Tarefa
            sol.getSol().get(maquina).remove(sol.getSol().get(maquina).indexOf(tarefa));
            
            //Adicionando tarefa retirada ao conjunto Q
            conjQ.add(tarefa);
            
        }
        
        return conjQ;        
    
    }
    
}
