/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Remocoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Remove q tarefas inicias de uma máquina aleatória, se esta máquina não for suficiente, seleciona-se outra máquina aleatória e remove suas tarefas. 
public class RemocaoMaqAleatoria extends Remocoes{
    
    public ArrayList<Integer> execute(Solucao sol, Instancia instancia, int tamQ, Random rand){
    
        ArrayList<Integer> conjQ = new ArrayList<Integer>();

        //Enquanto não pegar o total de tarefas para Q
        while(tamQ > conjQ.size()){
        
            //Pega uma máquina aleatória
            int randMaquina = rand.nextInt(instancia.getNumMaqs());
            while(sol.getSol().get(randMaquina).size() < 1)
                randMaquina = rand.nextInt(instancia.getNumMaqs());
        
            //Percorre as tarefas da máquina
            int tamMaq = sol.getSol().get(randMaquina).size();
            for(int i=0; i<tamMaq; i++){
  
                //Já pegou o total de Q?
                if(tamQ > conjQ.size()){

                    //Remove sempre o primeiro da lista ("Fila")
                    int randTarefa = 0;
                    
                    //Atualizando o custo para remover a Tarefa
                    double custo = sol.regraDelta_Retirar2(instancia, randMaquina, sol.getSol().get(randMaquina).get(randTarefa), randTarefa);
                    sol.getCustoMaq().set(randMaquina, (sol.getCustoMaq().get(randMaquina) + custo));

                    //Removendo Tarefa
                    int tarefaRetirada = sol.getSol().get(randMaquina).remove(randTarefa);
                
                    //Adicionando tarefa retirada ao conjunto Q
                    conjQ.add(tarefaRetirada);
                
                }
                else{
                    break;
                }
            }
        }
        
        return conjQ;  
    }
    
}
