/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Heuristicas;

//import Principal.Elite;
import Principal.Dominancia;
import Principal.Instancia;
import Principal.Maquinas;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author DecomLuciano
 */

//Busca Local: Estratégia First Improviment e Vizinhança MI(Múltipla Inserção ou Multiple Insertion)
//Critério de Aceitação é mais detalhado do que o de FI_MI_2
public class FI_MI {
    
    public static Solucao execute(Instancia instancia, Solucao s){
        
        //Mudança (04/10/2017): Não irá modificar a solução s (original)
        Solucao sol2 = new Solucao(instancia);
        sol2.clonarSolucoes(s);
     
        //Armazena as máquinas da Solução por ordem decrescente
        ArrayList<Maquinas> make = new ArrayList<Maquinas>();
        for(int i=0; i < instancia.getNumMaqs(); i++){
            make.add(new Maquinas(i, sol2.getCustoMaq().get(i)));
        }
        Collections.sort(make);
        
        //
        //ArrayList<Integer> vectorL1 = new ArrayList<Integer>();
        //for(int l=0;l<instancia.getL();l++)
        //    vectorL1.add(l);
        //Collections.shuffle(vectorL1);
        //System.out.println(vectorL1);
        
        
        //Percorrendo as tarefas da máquina K
        for(int k=0; k < instancia.getNumMaqs(); k++){
            for(int auxJ=0; auxJ < sol2.getSol().get(make.get(k).getIndice()).size(); auxJ++){
                  
                //Máquina K
                int indiceK = make.get(k).getIndice();

                //Custo Antigo de K
                double custoAntigoK = sol2.getCustoMaq().get(indiceK);

                //Tarefa a ser Apagada
                int j = sol2.getSol().get(make.get(k).getIndice()).get(auxJ);

                //Atualizando o Custo
                double custoK = sol2.regraDelta_Retirar2(instancia, indiceK, j, auxJ);
                sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoK));

                //Removendo Tarefa
                sol2.getSol().get(indiceK).remove(auxJ);

                //Percorrendo todas as posições da máquina I
                for(int i=instancia.getNumMaqs()-1; i >= 0; i--){
                    for(int auxJLin=0; auxJLin <= sol2.getSol().get(make.get(i).getIndice()).size(); auxJLin++){

                        //NOVO: Percorrendo índice de velocidades para para todas as posições
                        //for(int indL1=0; indL1 < instancia.getL() ; indL1++){
                            
                            //
                            //int l1 = vectorL1.get(indL1);
                            
                            //NOVO: Alterando a velocidade de processamento da tarefa J
                            //int antigaSpeed = sol2.getSpeed()[j];
                            //sol2.alterarSpeed(j, l1);
                            
                            //Máquina I
                            int indiceI = make.get(i).getIndice();

                            //Custo Antigo da máquina I
                            double custoAntigoI = sol2.getCustoMaq().get(indiceI);

                            //Inserindo Tarefa
                            if( (auxJLin == sol2.getSol().get(indiceI).size()) || sol2.getSol().get(indiceI).isEmpty() ){
                                //Última Posição
                                sol2.getSol().get(indiceI).add(j);
                            }
                            else{
                                //Posição Intermediária
                                sol2.getSol().get(indiceI).add(auxJLin, j);
                            }

                            //Atualizando o Custo
                            double custoI = sol2.regraDelta_Inserir2(instancia, indiceI, j, auxJLin);
                            sol2.getCustoMaq().set(indiceI, (sol2.getCustoMaq().get(indiceI) + custoI));

                            //NOVO: sol2 domina s ?
                            if(Dominancia.definirDominancia(sol2, s) == 1 || Dominancia.definirDominancia(sol2, s) == 2 || Dominancia.definirDominancia(sol2, s) == 5){
                                //Fim da busca!
                                return sol2;
                            }
                            //Desfazer Movimento de inserir a tarefa j na posição auxJLin
                            else{
                                //Remove a tarefa j
                                sol2.getSol().get(indiceI).remove(auxJLin);
                                //Atualiza com o custo anterior
                                sol2.getCustoMaq().set(indiceI, custoAntigoI);
                                //NOVO: Atualiza a tarefa com a velocidade antiga
                                //sol2.alterarSpeed(j, antigaSpeed);
                            }
                        //}
                    }
                }
                
                //Desfaz movimento: volta com a tarefa j para a posição auxJ na máquina K
                sol2.getSol().get(indiceK).add(auxJ, j);
                //Atualiza com o custo anterior
                sol2.getCustoMaq().set(indiceK, custoAntigoK);
            }
        }
        
        //Fim da busca! Não encontrou uma solução melhor nesta vizinhança
        return sol2;
    }
    
}
