/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Heuristicas;

import Principal.Instancia;
import Principal.Solucao;
import java.util.Random;

/**
 *
 * @author luciano
 */
public class Perturb {
    
    public static Solucao execute(Solucao sol, Instancia instancia){
        

        Random rand = new Random();
            
        //M1
        int randMaquina1 = rand.nextInt(instancia.getNumMaqs());
        while(sol.getSol().get(randMaquina1).size() <= 1)
            randMaquina1 = rand.nextInt(instancia.getNumMaqs());
        
        //M2
        int randMaquina2 = rand.nextInt(instancia.getNumMaqs());
        while(sol.getSol().get(randMaquina2).size() <= 1)
            randMaquina2 = rand.nextInt(instancia.getNumMaqs());
        
        //Pegando uma Tarefa Aleatória da Máquina 1
        int randT1 = rand.nextInt(sol.getSol().get(randMaquina1).size());
        
        //Custo para remover a Tarefa
        double custo = sol.regraDelta_Retirar2(instancia, randMaquina1, sol.getSol().get(randMaquina1).get(randT1), randT1);
        sol.getCustoMaq().set(randMaquina1, (sol.getCustoMaq().get(randMaquina1) + custo));
        
        //Removendo Tarefa
        int tarefaRetirada1 = sol.getSol().get(randMaquina1).remove(randT1);
        
        //System.out.println("Maq1:" + randMaquina1 + " Maq2:" + randMaquina2 + " Tarefa: " + tarefaRetirada1);
        
        Solucao solPert = new Solucao(instancia); //Solução Pertubada
        solPert.clonarSolucoes(sol);
        
        //Armazerá as posições
        int posicaoEscolhida;
        boolean ultimaPosicao = false;
        
        //Inserindo a Tarefa na Máquina 2
        double auxCusto = 99999;
        for(int i=0; i < sol.getSol().get(randMaquina2).size()+1; i++){

            Solucao sol2 = new Solucao(instancia);
            sol2.clonarSolucoes(sol);
            
            //Última Posição
            if(i == (sol2.getSol().get(randMaquina2).size()) ){ //Último item
                sol2.getSol().get(randMaquina2).add(tarefaRetirada1);
                ultimaPosicao = true;
            }
            //Posição Intermediária
            else {
                ultimaPosicao = false;
                sol2.getSol().get(randMaquina2).add(i, tarefaRetirada1);
            }

            //Atualizando a Posição Escolhida
            if(!ultimaPosicao)
               posicaoEscolhida = i;
            else
               posicaoEscolhida = sol2.getSol().get(randMaquina2).size()-1;
            
            //Custo - Inserindo a Tarefa
            double custoInserir = sol2.regraDelta_Inserir2(instancia, randMaquina2, tarefaRetirada1, posicaoEscolhida);
            sol2.getCustoMaq().set(randMaquina2, (sol2.getCustoMaq().get(randMaquina2) + custoInserir));
            
            if(custoInserir < auxCusto){
                auxCusto = custoInserir;
                solPert.clonarSolucoes(sol2);
            }
        }
        
        return solPert;
    }    
}