/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Partes_MOALNSD;

import Principal.Dominancia;
import Principal.Instancia;
import Principal.Maquinas;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author luciano
 */
public class FI_SS_MULT {
    
    public static Solucao execute(Instancia instancia, Solucao s){
        
        //
        //s.calcularTEC();
        
        //Mudança (04/10/2017): Não irá modificar a solução s (original)
        Solucao sol2 = new Solucao(instancia);
        sol2.clonarSolucoes(s);
        
        //Armazena as máquinas da Solução por ordem decrescente
        ArrayList<Maquinas> make = new ArrayList<Maquinas>();
        for(int i=0; i < instancia.getNumMaqs(); i++){
            make.add(new Maquinas(i, sol2.getCustoMaq().get(i)));
        }
        Collections.sort(make);
        
        //Armazena as velocidades em ordem aleatória
        ArrayList<Integer> vectorL1 = new ArrayList<Integer>();
        for(int l=0;l<instancia.getL();l++){
            vectorL1.add(l);
        }    
        Collections.shuffle(vectorL1);
        
        //NOVO: Percorrendo todos os índice de velocidade para a tarefa j
        for(int indL1=0; indL1 < instancia.getL() ; indL1++){
        
            //Percorrendo as máquinas
            for(int k=0; k < instancia.getNumMaqs(); k++){

                //Percorrendo todas as tarefas de K em ordem crescente pelo índice da posição
                for(int auxJ=0; auxJ < sol2.getSol().get(make.get(k).getIndice()).size()-1; auxJ++){

                    //
                    int l1 = vectorL1.get(indL1);

                    //Indice da Máquina
                    int indiceK = make.get(k).getIndice();

                    //System.out.println("LF Passei: " + l1);

                    //Custo Antigo
                    double custoAntigoK = sol2.getCustoMaq().get(indiceK);

                    //NOVO: Custo da TEC na análise de máquina k
                    double custoAntigoK_TEC = sol2.getTEC();

                    //Tarefa J
                    int j = sol2.getSol().get(indiceK).get(auxJ);

                    //NOVO: Alterando as velocidades das tarefas e armazenando os custos antigos
                    //O custo é atualizado porque a tarefa deve ser removida já com o custo da nova VELOCIDADE
                    //Atualizando custos
                    double custoTrocarVel_j = sol2.regraDelta_Velocidade(instancia, indiceK, j, l1);
                    sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoTrocarVel_j));
                    //Trocando velocidades
                    int antigaSpeed_j = sol2.getSpeed()[j];
                    sol2.alterarSpeed(j, l1);
                    //System.out.println(sol2.calcularMakespan() + " x " + s.calcularMakespan() + " =<= " + sol2.calcularTEC() + " x " + s.calcularTEC());
                    //sol2.imprimirSolucao();

                    //Atualiza o custo da TEC
                    /*(double custoProc_Antigo  = (instancia.getProc()[indiceK][j]/instancia.getV()[antigaSpeed_j]);
                    double custoRemocao_TEC  = (instancia.getLambda()[antigaSpeed_j]) * ((double) instancia.getPi()[indiceK]/60) * (custoProc_Antigo);
                    double custoProc_Novo    = (instancia.getProc()[indiceK][j]/instancia.getV()[l1]);
                    double custoInsercao_TEC = (instancia.getLambda()[l1]) * ((double) instancia.getPi()[indiceK]/60) * (custoProc_Novo);
                    double custoNovoK_TEC = custoAntigoK_TEC - custoRemocao_TEC + custoInsercao_TEC;
                    //sol2.setTEC(custoNovoK_TEC);*/

                    //
                    sol2.calcularTEC();

                    //NOVO: 
                    if(sol2.calcularFO2()< s.calcularFO2()){

                        //System.out.println("Passei: " + l1);
                        //Fim da busca!
                        
                        return sol2;
                    }
                    //Desfazendo o movimento de troca
                    else{

                        //
                        sol2.getCustoMaq().set(indiceK, custoAntigoK);

                        /*NOVO: */                         
                        sol2.alterarSpeed(j, antigaSpeed_j);

                        //NOVO: Custo da TEC na análise de máquina k
                        sol2.setTEC(custoAntigoK_TEC);
                        //sol2.calcularTEC();
                    }
                }
            }
        }    
  
        //Fim da busca! Não encontrou uma solução melhor nesta vizinhança
        return s;
    }
    
}
