/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Partes_MOALNSD;

import Principal.Instancia;
import Principal.Maquinas;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author DecomLuciano
 */

//Busca Local: Estratégia First Improviment e Vizinhança TMM(Troca na Mesma Máquina) ou SSM(Swap In The Same Machine )
public class FI_TMM_MULT {
    
    //Obs - 18/12/2017: Nesta busca local a TEC nunca muda porque as trocas são realizadas na mesma máquina 
    public static Solucao execute(Instancia instancia, Solucao s){
        
        //
        //s.calcularTEC();
        
        //Mudança (04/10/2017): Não irá modificar a solução s (original)
        Solucao sol2 = new Solucao(instancia);
        sol2.clonarSolucoes(s);
        
        //Armazena as máquinas da Solução por ordem decrescente
        ArrayList<Maquinas> make = new ArrayList<Maquinas>();
        for(int i=0; i < instancia.getNumMaqs(); i++){
            make.add(new Maquinas(i, sol2.getCustoMaq().get(i)));
        }
        Collections.sort(make);
        
        //
        /*ArrayList<Integer> vectorL1 = new ArrayList<Integer>();
        ArrayList<Integer> vectorL2 = new ArrayList<Integer>();
        for(int l=0;l<instancia.getL();l++){
            vectorL1.add(l);
            vectorL2.add(l);
        }    
        Collections.shuffle(vectorL1);
        Collections.shuffle(vectorL2);*/
        
        
        //Percorrendo as máquinas
        for(int k=0; k < instancia.getNumMaqs(); k++){
            
            //Percorrendo todas as tarefas de K em ordem crescente pelo índice da posição
            for(int auxJ=0; auxJ < sol2.getSol().get(make.get(k).getIndice()).size()-1; auxJ++){
                
                //NOVO: Percorrendo todos os índice de velocidade para a tarefa j
                //for(int indL1=0; indL1 < instancia.getL() ; indL1++){
   
                    //
                    //int l1 = vectorL1.get(indL1);
                    
                    //Percorrendo todas as tarefas de K em ordem decrescente pelo índice da posição
                    for(int auxJLin=auxJ+1; auxJLin < sol2.getSol().get(make.get(k).getIndice()).size(); auxJLin++){
                
                        //NOVO: Percorrendo todos os índice de velocidade para a tarefa jLin
                        //for(int indL2=0; indL2 < instancia.getL() ; indL2++){

                            //
                            //int l2 = vectorL2.get(indL2);
                            
                            //Indice da Máquina
                            int indiceK = make.get(k).getIndice();

                            //Custo Antigo
                            double custoAntigoK = sol2.getCustoMaq().get(indiceK);
                            
                            //NOVO: Custo da TEC na análise de máquina k
                            //double custoAntigoK_TEC = sol2.getTEC();
                            
                            //Tarefa J
                            int j = sol2.getSol().get(indiceK).get(auxJ);

                            //Tarefa JLinha
                            int jLin = sol2.getSol().get(indiceK).get(auxJLin);
                    
                            //NOVO: Alterando as velocidades das tarefas e armazenando os custos antigos
                            //O custo é atualizado porque a tarefa deve ser removida já com o custo da nova VELOCIDADE
                            //Atualizando custos
                            /*double custoTrocarVel_j = sol2.regraDelta_Velocidade(instancia, indiceK, j, l1);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoTrocarVel_j));
                            double custoTrocarVel_jLin = sol2.regraDelta_Velocidade(instancia, indiceK, jLin, l2);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoTrocarVel_jLin));
                            //Trocando velocidades
                            int antigaSpeed_j = sol2.getSpeed()[j];
                            sol2.alterarSpeed(j, l1);
                            int antigaSpeed_jLin = sol2.getSpeed()[jLin];
                            sol2.alterarSpeed(jLin, l2);
                            */
                            
                            //Atualiza Custo para Remover J
                            double custoRetirarJ = sol2.regraDelta_Retirar2(instancia, indiceK, j, auxJ);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoRetirarJ));

                            //Removendo J e inserindo JLin
                            sol2.getSol().get(indiceK).remove(auxJ);
                            sol2.getSol().get(indiceK).add(auxJ, jLin);

                            //Atualiza Custo para Inserir JLin
                            double custoInserirJLin = sol2.regraDelta_Inserir2(instancia, indiceK, jLin, auxJ);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoInserirJLin));

                            //Atualiza Custo para Remover JLin
                            double custoRetirarJLin = sol2.regraDelta_Retirar2(instancia, indiceK, jLin, auxJLin);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoRetirarJLin));

                            //Removendo JLin e inserindo J
                            sol2.getSol().get(indiceK).remove(auxJLin);
                            sol2.getSol().get(indiceK).add(auxJLin, j);

                            //Atualiza Custo para Inserir J
                            double custoInserirJ = sol2.regraDelta_Inserir2(instancia, indiceK, j, auxJLin);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoInserirJ));

                            //System.out.println("Passei: " + sol2.calcularFO_BL() + " \t " + s.calcularFO_BL() + "  " + k);
                            
                            //
                            //sol2.calcularTEC();
                            
                            //NOVO: FOs x Pesos
                            if(sol2.calcularFO2() < s.calcularFO2()){
                                
                                //System.out.println("Bosta");
                            
                            //Custo Novo
                            //double custoNovoK = sol2.getCustoMaq().get(indiceK); 
                            //if(custoAntigoK > custoNovoK){
                                
                                
                                
                            //if(Dominancia.definirDominancia(sol2, s) == 1 || Dominancia.definirDominancia(sol2, s) == 2 || Dominancia.definirDominancia(sol2, s) == 5){
                                //Fim da busca!
                                return sol2;
                            }
                            //Desfazendo o movimento de troca
                            else{

                                //Volta com as tarefas para as posições anteriores na máquina K
                                j = sol2.getSol().get(indiceK).get(auxJ);
                                jLin = sol2.getSol().get(indiceK).get(auxJLin);
                                sol2.getSol().get(indiceK).remove(auxJ);
                                sol2.getSol().get(indiceK).add(auxJ, jLin);
                                sol2.getSol().get(indiceK).remove(auxJLin);
                                sol2.getSol().get(indiceK).add(auxJLin, j);
                                sol2.getCustoMaq().set(indiceK, custoAntigoK);

                                /*NOVO: Atualiza as tarefas com as velocidades antigas, é importante
                                destacar que as tarefas j e jLin trocaram de nome no passo anterior */                         
                                //sol2.alterarSpeed(jLin, antigaSpeed_j);
                                //sol2.alterarSpeed(j, antigaSpeed_jLin);
                                
                                //NOVO: Custo da TEC na análise de máquina k
                                //sol2.setTEC(custoAntigoK_TEC);
                            }
                        //}    
                    }
                //}    
            }
        } 
        
        //Fim da busca! Não encontrou uma solução melhor nesta vizinhança
        return s;
    }
    
}
