/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Insercoes;

import Principal.Instancia;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Inserção gulosa após lambda inserções aleatórias
public class InsercaoLambda extends Insercoes{
    
    public int getIndice(){
        return 4;
    }
    
    
    public Solucao execute(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand){
        
        //Embaralhando conjQ
        Collections.shuffle(conjQ);
        
        double lambda = 0.5;
        
        //Definindo o tamanho das duas partes
        int tamParte1 = (int) (conjQ.size() * lambda);
        int tamParte2 = conjQ.size() - tamParte1;
                            
        //Parte1
        ArrayList<Integer> parte1_conjQ = new ArrayList<Integer>();
        int contador = 0;
        for(int i=0; i<tamParte1; i++){
            parte1_conjQ.add(conjQ.get(contador));
            contador++;
        }
        
        //Parte2
        ArrayList<Integer> parte2_conjQ = new ArrayList<Integer>();
        for(int i=0; i<tamParte2; i++){
            parte2_conjQ.add(conjQ.get(contador));
            contador++;
        }
        
        //System.out.println("Parte1: " + parte1_conjQ);
        //System.out.println("Parte2: " + parte2_conjQ);
        
        //Execução usando o método de Inserção Aleatória
        sol = execute_InsercaoAleatoria(sol, instancia, parte1_conjQ, rand);
        
        //Execução usando o método de Inserção Gulosa
        InsercaoGuloso insercaoGuloso = new InsercaoGuloso();
        sol = insercaoGuloso.execute(sol, instancia, parte2_conjQ, rand);
        
        return sol;
    }
    
    //Inserção aleatória
    public static Solucao execute_InsercaoAleatoria(Solucao sol, Instancia instancia, ArrayList<Integer> conjQ, Random rand){
    
        //Percorrendo as tarefas da lista
        for (int a=0; a<conjQ.size(); a++){
            
            //Pega uma máquina aleatoriamente
            int randMaquina = rand.nextInt(instancia.getNumMaqs());
            
            //Pega uma posição aleatória desta máquina
            int randPosicao = rand.nextInt(sol.getSol().get(randMaquina).size()+1);
            
            //Insere a tarefa nesta posição
            int tarefa = conjQ.get(a);
            if(randPosicao == sol.getSol().get(randMaquina).size()) //última posição
                sol.getSol().get(randMaquina).add(tarefa);
            else
                sol.getSol().get(randMaquina).add(randPosicao, tarefa);
            
            //Atualizando o Custo
            double custo = sol.regraDelta_Inserir2(instancia, randMaquina, tarefa, randPosicao);
            sol.getCustoMaq().set(randMaquina, (sol.getCustoMaq().get(randMaquina) + custo));
        
        }
        
        return sol;
    }
    
}
