/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Remocoes;

import Principal.*;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Remove q tarefas aleatórias em máquinas aleatórias
public class RemocaoAleatoria extends Remocoes{
    
    public ArrayList<Integer> execute(Solucao sol, Instancia instancia, int tamQ, Random rand){
    
        ArrayList<Integer> conjQ = new ArrayList<Integer>();
        
        for(int i=0; i<tamQ; i++){
         
            //Pega uma máquina aleatória
            int randMaquina = rand.nextInt(instancia.getNumMaqs());
            while(sol.getSol().get(randMaquina).size() < 1){
                randMaquina = rand.nextInt(instancia.getNumMaqs());
            }    
            
            //Pega uma tarefa aleatória
            int randTarefa = rand.nextInt(sol.getSol().get(randMaquina).size());
            
            //Atualizando o custo para remover a Tarefa
            double custo = sol.regraDelta_Retirar2(instancia, randMaquina, sol.getSol().get(randMaquina).get(randTarefa), randTarefa);
            sol.getCustoMaq().set(randMaquina, (sol.getCustoMaq().get(randMaquina) + custo));
        
            //Removendo Tarefa
            int tarefaRetirada = sol.getSol().get(randMaquina).remove(randTarefa);
            
            //Adicionando tarefa retirada ao conjunto Q
            conjQ.add(tarefaRetirada);
        
        }    
        
        return conjQ;        
    
    }
}
