/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ALNS_Remocoes;

import Principal.Instancia;
import Principal.Maquinas;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author UFOPLuciano
 */

//Remove q tarefas inicias da maior máquina, se esta máquina não for suficiente, seleciona-se a segunda maior máquina e remove suas tarefas. 
public class RemocaoMaqMaior extends Remocoes{
    
    public ArrayList<Integer> execute(Solucao sol, Instancia instancia, int tamQ, Random rand){
    
        ArrayList<Integer> conjQ = new ArrayList<Integer>();
        
        //Armazena as máquinas da Solução por ordem decrescente
        ArrayList<Maquinas> make = new ArrayList<Maquinas>();
        for(int i=0; i < instancia.getNumMaqs(); i++){
            make.add(new Maquinas(i, sol.getCustoMaq().get(i)));
        }
        Collections.sort(make);

        //Enquanto não pegar o total de tarefas para Q
        int contadorMaq = 0;
        while(tamQ > conjQ.size()){
        
            //Pega a maior máquina
            int randMaquina = make.get(contadorMaq).getIndice();
            contadorMaq++;
        
            //Percorre as tarefas da máquina
            int tamMaq = sol.getSol().get(randMaquina).size();
            for(int i=0; i<tamMaq; i++){
  
                //Já pegou o total de Q?
                if(tamQ > conjQ.size()){

                    //Remove sempre o primeiro da lista ("Fila")
                    int randTarefa = 0;
                    
                    //Atualizando o custo para remover a Tarefa
                    double custo = sol.regraDelta_Retirar2(instancia, randMaquina, sol.getSol().get(randMaquina).get(randTarefa), randTarefa);
                    sol.getCustoMaq().set(randMaquina, (sol.getCustoMaq().get(randMaquina) + custo));

                    //Removendo Tarefa
                    int tarefaRetirada = sol.getSol().get(randMaquina).remove(randTarefa);
                
                    //Adicionando tarefa retirada ao conjunto Q
                    conjQ.add(tarefaRetirada);
                
                }
                else{
                    break;
                }
            }
        }
        
        return conjQ;        
    }
    
}
