/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Heuristicas;

import Principal.Dominancia;
import Principal.Instancia;
import Principal.Maquinas;
import Principal.Solucao;
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author luciano
 */
public class FI_SS {
    
    public static Solucao execute(Instancia instancia, Solucao s){
        
        //Mudança (04/10/2017): Não irá modificar a solução s (original)
        Solucao sol2 = new Solucao(instancia);
        sol2.clonarSolucoes(s);
        
        //Armazena as máquinas da Solução por ordem decrescente
        ArrayList<Maquinas> make = new ArrayList<Maquinas>();
        for(int i=0; i < instancia.getNumMaqs(); i++){
            make.add(new Maquinas(i, sol2.getCustoMaq().get(i)));
        }
        Collections.sort(make);
        
        //
        ArrayList<Integer> vectorL1 = new ArrayList<Integer>();
        for(int l=0;l<instancia.getL();l++){
            vectorL1.add(l);
        }    
        Collections.shuffle(vectorL1);
        
        //NOVO: Percorrendo todos os índice de velocidade para a tarefa j
        for(int indL1=0; indL1 < instancia.getL() ; indL1++){
        
            //Percorrendo as máquinas
            for(int k=0; k < instancia.getNumMaqs(); k++){

                //Percorrendo todas as tarefas de K em ordem crescente pelo índice da posição
                for(int auxJ=0; auxJ < sol2.getSol().get(make.get(k).getIndice()).size()-1; auxJ++){

                    //NOVO: Percorrendo todos os índice de velocidade para a tarefa j
                    //for(int indL1=0; indL1 < instancia.getL() ; indL1++){

                            //
                            int l1 = vectorL1.get(indL1);

                            //Indice da Máquina
                            int indiceK = make.get(k).getIndice();

                            //System.out.println("LF Passei: " + l1);
                            
                            //Custo Antigo
                            double custoAntigoK = sol2.getCustoMaq().get(indiceK);

                            //Tarefa J
                            int j = sol2.getSol().get(indiceK).get(auxJ);

                            //NOVO: Alterando as velocidades das tarefas e armazenando os custos antigos
                            //O custo é atualizado porque a tarefa deve ser removida já com o custo da nova VELOCIDADE
                            //Atualizando custos
                            double custoTrocarVel_j = sol2.regraDelta_Velocidade(instancia, indiceK, j, l1);
                            sol2.getCustoMaq().set(indiceK, (sol2.getCustoMaq().get(indiceK) + custoTrocarVel_j));
                            //Trocando velocidades
                            int antigaSpeed_j = sol2.getSpeed()[j];
                            sol2.alterarSpeed(j, l1);

                            //System.out.println(sol2.calcularMakespan() + " x " + s.calcularMakespan() + " =<= " + sol2.calcularTEC() + " x " + s.calcularTEC());
                            
                            //NOVO: sol2 domina s ?
                            if(Dominancia.definirDominancia(sol2, s) == 1 || Dominancia.definirDominancia(sol2, s) == 2 || Dominancia.definirDominancia(sol2, s) == 5){
                                
                                //System.out.println("Passei: " + l1);
                                //Fim da busca!
                                return sol2;
                            }
                            //Desfazendo o movimento de troca
                            else{

                                //
                                sol2.getCustoMaq().set(indiceK, custoAntigoK);

                                /*NOVO: Atualiza as tarefas com as velocidades antigas, é importante
                                destacar que as tarefas j e jLin trocaram de nome no passo anterior */                         
                                sol2.alterarSpeed(j, antigaSpeed_j);
                            }
                    //}
                }
            }
            
        }    
  
        //Fim da busca! Não encontrou uma solução melhor nesta vizinhança
        return sol2;
    }
    
}
